\ Пример работы с QT через FQT.DLL
\ MGW 

REQUIRE MGW  qtf/stdlib.f        // Небольшая библиотека для совместимости 
if=L REQUIRE HYPE qtf/hype3.f         // Поддержка объектов, без них тоскливо
if=L REQUIRE csz  qtf/CS.F            // Работа со строками   

if=W REQUIRE HYPE ~day\hype3\hype3.f  // Поддержка объектов, без них тоскливо
if=W REQUIRE csz  ~day\common\CS.F    // Работа со строками

TRUE TO ?GUI                     // Только графика
DIS-OPT                          // Отключить оптимизатор

CODE test                        // Прерывание для внешнего отладчика
    INT 3
    RET
END-CODE
   
256 CONST$ str_usd    // Строка для сбора распечатки стека с строке состояния   
256 CONST$ str_eval   // Строка от evaluate для распечатки в окне
256 CONST$ str_debug  // Строка для работы отладчика

256 CONST$ s   // Буфер под строку 255 байт

// 256 CONST$ str_w   // Строка от .W для расп чисел в окне
256 CONST$ SaveUSD    // область для сохранения стека данных
VARIABLE  uSaveUSD    // Указатель для сохранения и востановления стека

: save_USD     // Сохранить стек данных в буфере SaveUSD
    DEPTH 0<> 
    IF
        DEPTH SaveUSD ! SaveUSD CELL + uSaveUSD !
        DEPTH 0 DO uSaveUSD @ ! CELL uSaveUSD +! LOOP
    ELSE
        0 SaveUSD !
    THEN
    ;
: restore_USD  // Востановить стек данных
    SaveUSD @ 0<>
    IF 
        SaveUSD @ CELLS SaveUSD + uSaveUSD !
        0 SaveUSD @ SWAP DO uSaveUSD @ @ CELL NEGATE uSaveUSD +! LOOP
    THEN
    ;

VARIABLE APP                // Ссылка на QApplication 

// --- Точки входа -----------------------

if=L Library" libc.so.6" libc
if=L Library@    libc 1 CDECL-Call" strlen"                 strlen
if=L // Файловые операции ввода/вывода
if=L Library@    libc 2 CDECL-Call" fopen"                  fopen    // Name Attr -- File
if=L Library@    libc 1 CDECL-Call" fclose"                 fclose   // File -- 0/N
if=L Library@    libc 3 CDECL-Call" fgets"                  fgets    // AStr Nкол File -- AStr/0=EOF

if=W  // Эксперимент с Windows API
if=W Library" user32.dll" user32
if=W Library@ user32 3 WINAPI-Call" GetWindowTextA" GetWindowText
if=W Library@ user32 2 WINAPI-Call" SetWindowTextA" SetWindowText

// Для поиска разд библиот в Linux необ дать команду, для разреш поиска *.so в тек каталоге
// LD_LIBRARY_PATH=`pwd`; export LD_LIBRARY_PATH
// c:\proj\dll\fqt\Debug\fqt.dll 
// Library" c:\proj\dll\fqt\Debug\fqt.dll" libfqt       // Грузанем библиотеку fqt в память
if=W    Library" fqt452.dll"   libfqt       // Грузанем библиотеку fqt в память
if=L    Library" fqt.so.2.0.0" libfqt       // Грузанем библиотеку fqt в память

Library@ libfqt  3 CDECL-Call" QT_AppD"                фСоздатьПриложение
// ---------------------------
Library@ libfqt  1 CDECL-Call" QT_QWidget"             фСоздатьОкно
Library@ libfqt  1 CDECL-Call" QT_QWidget_show"        фПокажиОкно
Library@ libfqt  3 CDECL-Call" QT_QWidget_move"        фПереместить
Library@ libfqt  3 CDECL-Call" QT_QWidget_resize"      фРазмер
Library@ libfqt  2 CDECL-Call" QT_QWidget_setLayout"   фВставитьВыравниватель
Library@ libfqt  2 CDECL-Call" QT_QWidget_onresize"    фУстСобИзмРазмера

Library@ libfqt  2 CDECL-Call" QT_QWidget_mouseMoveEvent"   фУстСобДвижМыша
Library@ libfqt  2 CDECL-Call" QT_QWidget_hideEvent"   фУстСобЗакрОкна

Library@ libfqt  2 CDECL-Call" QT_QWidget_setwindowtitle"  фЗаголовок
// ---------------------------
Library@ libfqt  1 CDECL-Call" QT_QTextEdit"           фСоздатьРедактор
Library@ libfqt  2 CDECL-Call" QT_QTextEdit_append"    фДобавитьСтроку
Library@ libfqt  1 CDECL-Call" QT_QTextEdit"           фОчистить
// ---------------------------
Library@ libfqt  0 CDECL-Call" QT_QString"             фСоздатьСтроку
Library@ libfqt  2 CDECL-Call" QT_QString_set"         фЗаписатьВстроку
Library@ libfqt  2 CDECL-Call" QT_QString_text"        фЧитаитИзСтроки1
Library@ libfqt        Extern" NameCodec"              NameCodec$
// ---------------------------
Library@ libfqt  1 CDECL-Call" QT_QLineEdit"           фСоздатьСтрокаРедактор
Library@ libfqt  2 CDECL-Call" QT_QLineEdit_onreturnPressed" фУстСобНажатиеCR
Library@ libfqt  2 CDECL-Call" QT_QLineEdit_text"      фЧитаитИзСтроки
Library@ libfqt  1 CDECL-Call" QT_QLineEdit_setfocus"  фУстановитьФокус
Library@ libfqt  1 CDECL-Call" QT_QLineEdit_clear"     фОчистить
// ---------------------------
Library@ libfqt  0 CDECL-Call" QT_QMessageBox"         фСоздатьMsgBox
Library@ libfqt  6 CDECL-Call" QT_QMessageBox_infb"    фИнформационное
// ---------------------------
Library@ libfqt  0 CDECL-Call" QT_QVBoxLayout"         фВертикальныйВыравниватель
Library@ libfqt  0 CDECL-Call" QT_QHBoxLayout"         фГоризонтальныйВыравниватель
Library@ libfqt  2 CDECL-Call" QT_QBoxLayout_addWidget" фДобавитьВиджет
Library@ libfqt  2 CDECL-Call" QT_QBoxLayout_addLayout" фДобавитьВыравниватель
// ---------------------------
Library@ libfqt  1 CDECL-Call" QT_QStatusBar"          фСтрокаСостояния
Library@ libfqt  2 CDECL-Call" QT_QStatusBar_setMes"   фУстановитьСообщение
// ---------------------------
Library@ libfqt  0 CDECL-Call" QT_QMainWindow"         фГлавноеОкно
Library@ libfqt  2 CDECL-Call" QT_QMainWindow_setCentralWidget"  фУстановитьЦентральныйВиджет
Library@ libfqt  2 CDECL-Call" QT_QMainWindow_setStatusBar"      фУстановитьСтрокаСостояния
Library@ libfqt  2 CDECL-Call" QT_QMainWindow_setMenuBar"        фУстановитьСтрокаМеню
// ---------------------------
Library@ libfqt  2 CDECL-Call" QT_QPushButton"          фКнопка
Library@ libfqt  2 CDECL-Call" QT_QPushButton_OnClick"  фНажатие
// ---------------------------
if=W Library@ libfqt  1 CDECL-Call" QT_QWidget_HWND"    фHWND
Library@ libfqt  1 CDECL-Call" QT_QWidget_this"         фTHIS  // Указатель на данныe fQWidget

Library@ libfqt  2 CDECL-Call" QT_QDialog"              фДиалог
// ---------------------------
// Library@ libfqt  1 CDECL-Call" QT_QGLWidget"            фGLWidget
// Library@ libfqt  2 CDECL-Call" QT_QGLWidget_InitGL"     фInitGL
// Library@ libfqt  2 CDECL-Call" QT_QGLWidget_ResizeGL"   фResizeGL
// Library@ libfqt  2 CDECL-Call" QT_QGLWidget_PaintGL"    фPaintGL

// Вот собственно главное. Работа с объектами C++
if=W Library" QtGui4.dll"    QtGui       // Грузанем библиотеку Qt в память
if=L Library" libQtGui.so.4" QtGui       // Грузанем библиотеку Qt в память

// Qt 4.3.2 собранная на C++ MSVC 6.0
// ------------------------------------
// if=W Library@ QtGui  0 THIS-CDECL-Win-VC-Call" ?show@QWidget@@QAEXXZ"  фshow  // QWidget.show();
// if=W Library@ QtGui  0 THIS-CDECL-Win-VC-Call" ?hide@QWidget@@QAEXXZ"  фhide  // QWidget.hide();
// if=W Library@ QtGui  0 THIS-CDECL-Win-VC-Call" ?isVisible@QWidget@@QBE_NXZ"  фisVisible  // bool QWidget.isVisible();
// bool QWidget.isVisibleTo();
// if=W Library@ QtGui  1 THIS-CDECL-Win-VC-Call" ?isVisibleTo@QWidget@@QBE_NPAV1@@Z"  фisVisible
// if=W Library@ QtGui  0 THIS-CDECL-Win-VC-Call" ?hasFocus@QWidget@@QBE_NXZ"  фhasFocus
// if=W Library@ QtGui  0 THIS-CDECL-Win-VC-Call" ?setFocus@QWidget@@QAEXXZ"  фsetFocus
// if=W Library@ QtGui  0 THIS-CDECL-Win-VC-Call" ?exec@QDialog@@QAEHXZ"  фexecDialog
// if=W Library@ QtGui  0 THIS-CDECL-Win-VC-Call" ?setModal@QDialog@@QAEX_N@Z"  фsetModal
// if=W Library@ QtGui  1 THIS-CDECL-Win-VC-Call" ?isVisibleTo@QWidget@@QBE_NPAV1@@Z"  фisVisible
// ------------------------------------

// Qt 4.5.2 собранная на C++ MinGW
// ------------------------------------
// Library@ QtGui  0 THIS-CDECL-Win-VC-Call" _ZN14QWidgetPrivate8show_sysEv"  фshow  // QWidget.show();
Library@ QtGui 1 THIS-CDECL-Win-MinGW-Call" _ZN7QWidget10setVisibleEb"  фshow  // QWidget.show();
Library@ QtGui 0 THIS-CDECL-Win-MinGW-Call" _ZNK7QWidget11isVisibleToEPS_"  фisVisible  // bool QWidget.isVisible();
Library@ QtGui 1 THIS-CDECL-Win-MinGW-Call" _ZN7QWidget8setFocusEN2Qt11FocusReasonE"  фsetFocus
Library@ QtGui 0 THIS-CDECL-Win-MinGW-Call" _ZN7QDialog4execEv"  фexecDialog
Library@ QtGui 0 THIS-CDECL-Win-MinGW-Call" _ZN7QDialog8setModalEb"  фsetModal
Library@ QtGui 1 THIS-CDECL-Win-MinGW-Call" _ZN15QAbstractButton7setTextERK7QString"  фКнопкаТекст
// ------------------------------------

// --------------- Работа с OpenGL ---------- проверка
// if=W Library" opengl32.dll" opengl32
// if=W Library@ opengl32  1 WINAPI-Call" glEnable"      glEnable
// if=W Library@ opengl32  3 WINAPI-Call" glColor3i"     glColor3i
// if=W Library@ opengl32  1 WINAPI-Call" glBegin"       glBegin
// if=W Library@ opengl32  0 WINAPI-Call" glEnd"         glEnd
// if=W Library@ opengl32  3 WINAPI-Call" glVertex3f"    glVertex3f
// if=W Library@ opengl32  2 WINAPI-Call" glVertex2i"    glVertex2i
// if=W Library@ opengl32  0 WINAPI-Call" glFlush"       glFlush
// if=W Library@ opengl32  4 WINAPI-Call" glViewport"    glViewport
// if=W Library@ opengl32  1 WINAPI-Call" glClear"       glClear
// if=W Library@ opengl32  4 WINAPI-Call" glClearColor"  glClearColor // цвет фона
// if=W Library@ opengl32  3 WINAPI-Call" glColor3f"     glColor3f
// if=W Library@ opengl32 12 WINAPI-Call" glOrtho"       glOrtho

0x0000 CONSTANT GL_POINTS
0x0001 CONSTANT GL_LINES

0x0B71 CONSTANT GL_DEPTH_TEST
0x0007 CONSTANT GL_QUADS
0x4000 CONSTANT GL_COLOR_BUFFER_BIT
0x0100 CONSTANT GL_DEPTH_BUFFER_BIT
0x0009 CONSTANT GL_POLYGON                        

// Базовый класс QWidget (основа так сказать), на него замыкаются другие виджеты
CLASS fQWidget
   1 CELLS PROPERTY adr_fQWidget   // Запомним адрес объекта
: create     // Инициализация класса
   0 фСоздатьОкно adr_fQWidget !
   ;
: show  // Показать 
//   adr_fQWidget @ фПокажиОкно DROP
    TRUE adr_fQWidget @ фshow DROP   // adr_fQWidget.setVisible(true);
   ;
: hide  // Скрыть 
//   adr_fQWidget @ фhide DROP
   FALSE adr_fQWidget @ фshow DROP   // adr_fQWidget.setVisible(false);
   ;
: isVisible  // ( -- bool ) Окно видимо? 
//   adr_fQWidget @ 0 фisVisible
   adr_fQWidget @ фisVisible
   ;
: hasFocus  // ( -- bool ) Имеет фокус? 
//   adr_fQWidget @ фhasFocus
   ;
: setFocus  // ( -- ) Установить фокус
//   adr_fQWidget @ фsetFocus DROP
   7 adr_fQWidget @ фsetFocus DROP
   ;
: move  // ( x y -- ) Переместить
   adr_fQWidget @ фПереместить DROP
   ;
: resize   // ( w h -- ) Изменить размер
   SWAP adr_fQWidget @ фРазмер DROP // CDECL-CALL DROP
   ;
: onresize // ( Adr -- ) Установить обраб собтия изм размера
   adr_fQWidget @ фУстСобИзмРазмера DROP // CDECL-CALL DROP
   ;
: onMouseMove // ( Adr -- ) Установить обраб собтия изм размера
   adr_fQWidget @ фУстСобДвижМыша DROP // CDECL-CALL DROP
   ;
: onHideWidget // ( Adr -- ) Установить обраб собтия изм размера
   adr_fQWidget @ фУстСобЗакрОкна DROP // CDECL-CALL DROP
   ;
: setwindowtitle  // ( Qstr -- ) Заголовок на окно
    adr_fQWidget @ фЗаголовок DROP // CDECL-CALL DROP
   ;
: setlayout  // ( Alayuot -- ) Выравниватель вставить в окно
    adr_fQWidget @ фВставитьВыравниватель DROP // CDECL-CALL DROP
   ;
if=W : HWND  //  Дай HWND окна
if=W     adr_fQWidget @ фHWND
if=W   ;
: THIS  // Выдай указатель на обл данных fQWidget
    adr_fQWidget @ фTHIS
   ;
: @ // ( Adr -- A ) Отдай непосредственный адрес объекта
   adr_fQWidget @
   ;
;CLASS

// Окно редактора - Наследует QWidget
fQWidget SUBCLASS fQTextEdit  
: create     // Инициализация класса
  0 фСоздатьРедактор SUPER adr_fQWidget !
  ;
: append     // ( Qstr -- ) добавить строку в TextEdit
  SUPER adr_fQWidget @ фДобавитьСтроку DROP
  ;
: clear      // Очистить окно
  SUPER adr_fQWidget @ фОчистить DROP
  ;
;CLASS

// QString - класс строк
CLASS fQString
   1 CELLS PROPERTY qs
: create     // Инициализация класса
   фСоздатьСтроку qs !
   ;
: set    // ( Astr -- )  Установить значение 
   qs @ фЗаписатьВстроку DROP 
   ;
: text   // ( Astr -- ) Вернуть значение 
   qs @ фЧитаитИзСтроки1 DROP
   ;
: @
  qs @ 
  ;
;CLASS   

// QLineEdit - редактор строки
fQWidget SUBCLASS fQLineEdit
: create     // Инициализация класса
   0 фСоздатьСтрокаРедактор SUPER adr_fQWidget !
   ;
// : set    // ( Astr -- )  Установить значение 
//    qs @ 2 aQString_set
//   ;
: text   // ( Astr -- ) Вернуть значение 
   SUPER adr_fQWidget @ фЧитаитИзСтроки DROP
   ;
: onreturnPressed  //  ( Adr -- ) Установить обработчик прерывания
   SUPER adr_fQWidget @ фУстСобНажатиеCR DROP
   ;
: clear   //  Вернуть значение 
   SUPER adr_fQWidget @ фОчистить DROP
   ;
: setfocus   //  Установить фокус
   SUPER adr_fQWidget @ фОчистить DROP
   ;
: @
  SUPER adr_fQWidget @ 
   ;
;CLASS   

// fQMessageBox - MsgBox - диалог модальное окно с загол и сообщением
fQWidget SUBCLASS fQMessageBox
: create     // Инициализация класса
   фСоздатьMsgBox SUPER adr_fQWidget !
   ;
: msgbox     // ( Aqstr_soob Aqstr_zag Nkn Ntip Aparent -- rez )
   SUPER adr_fQWidget @ фИнформационное 
   ;
;CLASS   

// Выравниватели по горизонтали и вертикали
CLASS fQLayout
   1 CELLS PROPERTY adr_fQLayout
: createV     // Инициализация класса QVBoxLayout
   фВертикальныйВыравниватель adr_fQLayout !
   ;
: createH     // Инициализация класса QHBoxLayout
   фГоризонтальныйВыравниватель adr_fQLayout !
   ;
: addWidget   // ( Aqwid -- )  Добавить выравниватель виджет
   adr_fQLayout @ фДобавитьВиджет DROP
   ;
: addLayout   // ( Alayuot -- ) Добавить вырвниватель в выравниватель
   adr_fQLayout @ фДобавитьВыравниватель DROP
   ;
: @
   adr_fQLayout @ 
   ;
;CLASS   

// СтатусСтрока Наследует QWidget
fQWidget SUBCLASS fQStatusBar
: create     // ( Aqwid --  ) Инициализация класса
   фСтрокаСостояния SUPER adr_fQWidget !
   ;
: setMes     // ( Qstr -- ) добавить строку в StatusBar
   SUPER adr_fQWidget @ фУстановитьСообщение DROP
   ;
;CLASS

// MainWindow Наследует QWidget -- Главное окно проекта (SDI или MDI)
fQWidget SUBCLASS fQMainWindow
: create     // ( Aqwid --  ) Инициализация класса
   фГлавноеОкно SUPER adr_fQWidget !
   ;
: setCentralWidget     // ( Aqwidg -- ) добавить центральный виджет в Главное окно
   SUPER adr_fQWidget @ фУстановитьЦентральныйВиджет DROP
   ;
: setStatusBar     // ( Aqstatbar -- ) добавить статус строку в Главное окно
   SUPER adr_fQWidget @ фУстановитьСтрокаСостояния DROP
   ;
: setMenuBar     // ( Aqmenubar -- ) добавить меню в Главное окно
   SUPER adr_fQWidget @ фУстановитьСтрокаМеню DROP
   ;
;CLASS

// ================ Диалог =======================
fQWidget SUBCLASS fQDialog
: create     // ( Aqwid --  ) Инициализация класса
   фДиалог SUPER adr_fQWidget !
   ;
: exec  // Выполнить
   SUPER adr_fQWidget @ фexecDialog
   ;
: setModal  // ( 0/1 -- ) Выполнить
   SUPER adr_fQWidget @ фsetModal
   ;
;CLASS

// =============== Кнопки ========================
fQWidget SUBCLASS fQPushButton
: create     // ( Astr Aqwid --  ) Инициализация класса
   фКнопка SUPER adr_fQWidget !
   ;
: onClick    // ( Acallback -- ) Установить обработчик 
SUPER adr_fQWidget @ фНажатие DROP
   ;
: setText    // ( Aqstring -- ) Установить надпись на кнопке
SUPER adr_fQWidget @ фКнопкаТекст DROP
   ;
;CLASS

// fQWidget SUBCLASS fQGLWidget
// : create     // ( Aqwid --  ) Инициализация класса
//    0 фGLWidget SUPER adr_fQWidget !
//    ;
// : InitGL // ( Adr -- ) Установить обраб собтия
//    SUPER adr_fQWidget @ фInitGL DROP
//    ;
// : ResizeGL // ( Adr -- ) Установить обраб собтия
//    SUPER adr_fQWidget @ фResizeGL DROP
//    ;
// : PaintGL // ( Adr -- ) Установить обраб собтия
//    SUPER adr_fQWidget @ фPaintGL DROP
//   ;
// ;CLASS


fQWidget       NEW win452

fQMainWindow   NEW wc1
fQTextEdit     NEW te1
fQString       NEW qs1
fQString       NEW qsTMP
fQString       NEW qs_debug
fQString       NEW qs_debug1
fQLineEdit     NEW le1
fQWidget       NEW wincon   // Создадим главный виджет окно
fQStatusBar    NEW sb1

fQLayout       NEW l1
fQLayout       NEW l2
fQTextEdit     NEW te2
fQLineEdit     NEW le2
// ------------------ Отладчик -------------
fQDialog       NEW debug3
fQString       NEW qs_debug3
fQTextEdit     NEW te3
fQLineEdit     NEW le3
fQLayout       NEW l3
// ------ Проверка кнопок ------------------
fQPushButton NEW k1
fQPushButton NEW k2
fQPushButton NEW k3

// Вывод в окно текста ---------------------
: TYPE_W   // ( As Nstr -- ) Вывести строку в окно
   DROP qs1 set     
   qs1 @ te1 append 
   ;

: SPACE_W str_usd S"  " CS+A ;
: .SN_W   // ( n --)   Распечатать n верхних элементов стека
   >R BEGIN
         R@
      WHILE
        SP@ R@ 1- CELLS + @ DUP 0< 
        IF DUP U>D (D.) str_usd ROT ROT CS+A <# S>D #(SIGNED) #> str_usd ROT ROT CS+A SPACE_W
        ELSE   S>D (D.) str_usd ROT ROT CS+A SPACE_W THEN
        R> 1- >R
      REPEAT RDROP
    ;
: .W   // ( n -- ) Число напечатать на окне te1
   S>D (D.) TYPE_W
   ;
: OK1_W  // Подготовить строку с распечаткой стека SD
    str_usd C0!
    DEPTH 6 U< IF
                 DEPTH IF str_usd S"  Ok ( " CS+A DEPTH .SN_W  str_usd S" )" CS+A
                       ELSE str_usd S"  Ok" CS+A
                       THEN
               ELSE str_usd S"  Ok ( [" CS+A DEPTH S>D (D.) str_usd ROT ROT CS+A str_usd S" ].. " CS+A
                    5 .SN_W str_usd S" )" CS+A
               THEN
    ; 
: DUMP_W  // 
    6 0 DO DUP I + C@ .W LOOP DROP 
    ;
// Отладчик: Пример 1 2 3 __ DROP __ // позволяет остановить прогу и показать стек
fQMessageBox NEW box1

: __    // ( Astr N -- ) Отладчик
    DROP qs_debug1 set  // строку в QString
    OK1_W str_usd 1+ qs_debug set 
    qs_debug @ qs_debug1 @ 1 1 0 box1 msgbox DROP  
    ;
: _    // ( -- ) Отладчик без аргумента
    S" Debug" __
    ;

    // Полезные слова
: ?def 
   WORD FIND IF S" найдено" ELSE S" НЕ найдено" THEN TYPE_W
   ;
// aonMouseEvent @ wc1 onMouseMove


VARIABLE aonMouseEvent
:NONAME
  S" ." TYPE
  0
  ; 1 CELLS CALLBACK: onMouseEvent ' onMouseEvent aonMouseEvent !
   
VARIABLE aonDebug3
256 CONST$ sdebug3
:NONAME  // ( a -- )
  qs_debug3 @ le3 text      // Команду из QLineEdit в QString
  sdebug3 qs_debug3 text    // Команду из QString в форт строку sdebug3
  qs_debug3 @ te3 append
  sdebug3 COUNT ['] EVALUATE CATCH // Выполнить команду
  le3 setFocus le3 clear // Очистить QLineEdit и передать на него фокус
  0
  ; 1 CELLS CALLBACK: onDebug3
' onDebug3 aonDebug3 !

: initDebug3 // Инициализация отладчика ver №3
   0 0 debug3 create
   qs_debug3 create
   l3 createV     // Вертикальный выравниватель
   te3 create     // Мемо окно, для вывода текст информации
   le3 create     
   te3 @ l3 addWidget  // Мемо поле в вертик выравниватель
   le3 @ l3 addWidget  // СтрокВВода в верт выравниватель
   l3 @ debug3 setlayout
   S" Интелектуальный отладчик" DROP qs_debug3 set qs_debug3 @ debug3 setwindowtitle
   aonDebug3 @ le3 onreturnPressed  // Поставим обработчик на событие
   ;

: _3 
   OK1_W str_usd 1+ qs_debug3 set qs_debug3 @ te3 append 
   le3 setFocus le3 clear // Очистить QLineEdit и передать на него фокус
   debug3 exec DROP
   ;
: _3W  // ( Astr Nstr -- ) Отобразить строку в интел отладчике
   DROP qs_debug3 set qs_debug3 @ te3 append 
   ;
: _3.  // ( N -- ) Отобразить число в интел отладчике
   S>D (D.) _3W
   ;

VARIABLE ak1
:NONAME
  _3 
  0
  ; 0 CELLS CALLBACK: onk1 ' onk1 ak1 !

   
// Обработка события OnResize
VARIABLE aonResize
: _tmp3  // ( a -- )
  S" ." TYPE
  0
  ;
' _tmp3 1 CELLS CALLBACK: onResize
' onResize aonResize !

// Обработка событий ---------------------
// : _tmp1  // ( a -- )  // Отдадим строку с QLineEdit в об строку
:NONAME  // ( a -- )  // Отдадим строку с QLineEdit в об строку
  DROP 
  restore_USD // А здесь востановить стек данных
  qs1 @ le1 text  // Команду из QLineEdit в QString
  qs1 @ te1 append
   s qs1 text      // Команду из QString в форт строку s
  str_eval C0! str_eval S" ---> " CS+A str_eval s COUNT CS+A str_eval COUNT TYPE_W // Команду в окно сонсоли
  s COUNT ['] EVALUATE CATCH // Выполнить команду
  0<> IF   S"  <font color=red>^-- Ошибка выполнения ...</font>" TYPE_W THEN
  OK1_W str_usd 1+ qs1 set
  qs1 @ sb1 setMes // Расп стек в СтатусСтрока
  le1 setFocus le1 clear // Очистить QLineEdit и передать на него фокус
  save_USD // Вот здесь надо выполнить сохранение стека данных
  0                    // возвращаемое значение (треб SPF)
  ; 1 CELLS CALLBACK: onCR     // Сработает на CR в le1:QLineEdit
VARIABLE aonCR  ' onCR aonCR !

// ПРоверки и утилиты
// S" lib/ext/help_w.f" INCLUDED

: HelpMessage  // Краткое руководство
   S" <font color=red size=5> Это прототип графической консоли для SPF с использованием Qt.</font>" TYPE_W
   S" <font color=red size=4> Работает в Windows и Linux на SPF 4.20</font>" TYPE_W
   S" -------------------------------------------------------------" TYPE_W
   S" Отладчик: " TYPE_W
   S" 1 2 3 _ SWAP _  - Показать состояние стека " TYPE_W
   S" 1 2 3 Aстроки __ DROP _  - Показать состояние стека с заголовком из строки Aстроки " TYPE_W
   S" Вместо TYPE вывод в окно консоли TYPE_W и аналогично .W" TYPE_W
   S" Можно использовать буфер обмена для ввода команд" TYPE_W
   S" HWND окна можно получить через метод HWND." TYPE_W
   S" " TYPE_W 
   S" Пример:               " TYPE_W
   S"     fQTextEdit NEW ОкноРедактора     \ Объекты, куда же без них" TYPE_W
   S"     ОкноРедактора create ОкноРедактора show  \  надо заменить на ОкноРедактора.create ОкноРедактора.show" TYPE_W
   S" if=W  S' Заголовок' DROP ОкноРедактора HWND SetWindowText  \ Заголовок через API Windows для примера ..." TYPE_W 
   S" -------------------------------------------------------------" TYPE_W
   S" S' Привет' DROP qsTMP set qsTMP @ k2 setText // Поменять надпись на средней кнопке" TYPE_W
   S" " TYPE_W 
   S" <font color=blue>Вводим команды форта в нижней строке.</font>" TYPE_W
   ;

   
// Основная процедура инициализации MainQT   
:NONAME  // ( a -- )  // Отдадим строку с QLineEdit в об строку
   DROP  // Снять со стека параметр пришедший ииз SO

   S" Debug `_3`" DROP 0 k1 create
   S" Knopka - 2" DROP 0 k2 create
   S" Knopka - 3" DROP 0 k3 create
   ak1 @ k1 onClick   // Установим событие (вызов отладчика)
      
   qs1 create       // создадим QString
   qsTMP create
   qs_debug create  // QString для отладчика
   qs_debug1 create  // QString для отладчика

   wincon create  // Центральнй виджет для Главного окна
   wc1 create     // Главное окно
   l1 createV     // Вертикальный выравниватель
   l2 createH     // Гориз выравниватель
   te1 create     // Мемо окно, для вывода текст информации
   box1 create
      
   wincon @ sb1 create // создадим СтатусСтрока
   le1 create          // создадим QString
   
   k1 @ l2 addWidget
   k2 @ l2 addWidget
   k3 @ l2 addWidget
   
   te1 @ l1 addWidget  // Мемо поле в вертик выравниватель
   le1 @ l1 addWidget  // СтрокВВода в верт выравниватель
   l2  @ l1 addLayout
   l1 @ wincon setlayout  // Главный выравниватель в центральный виджет
   sb1 @ wc1 setStatusBar
   wincon @ wc1 setCentralWidget 

   S" ~~~~ SPF & Qt ~~~~" DROP qs1 set  qs1 @ wc1 setwindowtitle
   800 500 wc1 resize 
   le1 setFocus 
   HelpMessage

   OK1_W str_usd 1+ qs1 set qs1 @ sb1 setMes 

   initDebug3

   aonCR @ le1 onreturnPressed  // Поставим обработчик на событие
   wc1 show
   le1 setFocus

  3  // Положить на стек параметр из SO ( проверки вызовов SO и DLL )
  0                              // возвращаемое значение (треб SPF)
  ; 1 CELLS CALLBACK: onForth     // Сработает на CR в le1:QLineEdit
VARIABLE aonForth ' onForth aonForth !

: run
if=L    LibraryLoad libc
if=W    LibraryLoad user32
        LibraryLoad QtGui
        LibraryLoad libfqt
        // Инициализация QT
if=L    aonForth @ ARGV ARGC фСоздатьПриложение
if=W    aonForth @ GetCommandLineA ASCIIZ> args SWAP фСоздатьПриложение
  
    DROP 
    BYE
    ;
 
run
    
\ ' run MAINX !
\  DIS-OPT
\  S" console.exe" SAVE 
\  BYE


\EOF
