// fqt.cpp : Defines the entry point for the DLL application.
//
#include "m2.h"

#ifdef LINUXF
  #define FQT_API 
#endif

typedef void (*ExecZIM_1_0)(void *);    //  определим  тип  для вызываемой функции
typedef void (*ExecZIM_0_0)(void);      //  определим  тип  для вызываемой функции
typedef void *(*ExecZIM_1_1)(void *);   //  определим  тип  для вызываемой функции

extern "C" { FQT_API void *adrExecZIM;   }              // Адрес под ExecZIM
extern "C" { FQT_API void *adrForthWord; }

extern "C" char NameCodec[80] = "UTF-8\0";  // Строка с именем кодовой страницы

#ifdef __MINGW32__
extern "C" FQT_API char NameCodec[80] = "Windows-1251\0";  // Строка с именем кодовой страницы
#endif

void *sav;

// ================= QApplication =================
// !!! Выдать QApplication на стек
extern "C" FQT_API void *QT_App(int qargc, char *qargv[]) {
	sav = (void *)new QApplication(qargc, qargv);
	return  sav;
}
// !!! Выдать QApplication на стек
extern "C" FQT_API  int QT_AppD(int qargc, char *qargv[], void *adrf) {
	sav = (void *)new QApplication(qargc, qargv);
#ifdef __MINGW32__
        __asm__("push %ebp");
        __asm__("push %eax");
#endif
#ifdef LINUXF
	__asm__("push %ebp");
	__asm__("push %eax");
#endif
#ifdef WINDOWSF
	_asm {
		push ebp;
		push eax;
	}
#endif
	((ExecZIM_1_0)adrf)((void *)sav);
#ifdef __MINGW32__
        __asm__("pop %eax");
        __asm__("pop %ebp");
#endif
#ifdef LINUXF
	__asm__("pop %eax");
	__asm__("pop %ebp");
#endif
#ifdef WINDOWSF
	_asm {
		pop eax;
		pop ebp;
	}
#endif
        ((QApplication *)sav)->exec();
 	return  0;
}
// !!! На вход указатель App из форта, на выход код завершения
extern "C" FQT_API int app_exec(void *aapp) {
	return ((QApplication *)aapp)->exec();
};
// ================= QWidget =================
zQWidget::zQWidget( QWidget* parent)
    : QWidget( parent )
{
	aOnResize = NULL;
	aMouseMoveEvent = NULL;
    aHideEvent = NULL;
}
zQWidget::~zQWidget()
{
}
void zQWidget::resizeEvent( QResizeEvent *a )
{
	if (aOnResize!= NULL) ((ExecZIM_1_0)aOnResize)((void *)a);
} 
void zQWidget::mouseMoveEvent( QMouseEvent *a )
{
	if (aMouseMoveEvent!= NULL)  ((ExecZIM_1_0)aMouseMoveEvent)((void *)a);
}
void zQWidget::hideEvent( QHideEvent *a )
{
	if (aHideEvent!= NULL)  ((ExecZIM_1_0)aHideEvent)((void *)a);
}

// !!! Выдать QWidget на стек
extern "C" FQT_API void *QT_QWidget(QWidget* parent) {
	return  new zQWidget(parent);
}
// !!! Показать QWidget
extern "C" FQT_API int QT_QWidget_show(zQWidget* qw) {
	qw->show();
	return 0;
}
// !!! Установить обработчик
extern "C" FQT_API void QT_QWidget_onresize(zQWidget* qw, void *uk) {
	qw->aOnResize = uk;
}
// !!! Установить обработчик
extern "C" FQT_API void QT_QWidget_mouseMoveEvent(zQWidget* qw, void *uk) {
        qw->aMouseMoveEvent = uk;
}
// !!! Установить обработчик
extern "C" FQT_API void QT_QWidget_hideEvent(zQWidget* qw, void *uk) {
        qw->aHideEvent = uk;
}

// !!! Resize
extern "C" FQT_API void QT_QWidget_resize(zQWidget* qw, int w, int h) {
	qw->resize(w, h);
}
// !!! Move
extern "C" FQT_API void QT_QWidget_move(zQWidget* qw, int x, int y) {
	qw->move(x, y);
}
// !!! setWindowTitle
extern "C" FQT_API void QT_QWidget_setwindowtitle(zQWidget* qw, QString *qstr) {
	qw->setWindowTitle(*qstr);
}
// !!! setLayout
extern "C" FQT_API void QT_QWidget_setLayout(zQWidget* qw, QLayout *layout) {
	qw->setLayout(layout);
}
// ===================================================
extern "C" FQT_API void *QT_QWidget_this(zQWidget* qw) {
	return &(qw->aOnResize);
}
// ===================================================
#ifdef WINDOWSF
extern "C" FQT_API void *QT_QWidget_HWND(zQWidget* qw) {
	return qw->winId();
}
#endif
#ifdef __MINGW32__
extern "C" FQT_API void *QT_QWidget_HWND(zQWidget* qw) {
        return qw->winId();
}
#endif

// ==================== QString ======================
// !!! Выдать QString на стек
extern "C" FQT_API void *QT_QString(void) {
	return  new QString();
}
// !!! Зпрись строки в QString
extern "C" FQT_API void QT_QString_set(QString *qstr, char *strz) {
	QTextCodec *codec = QTextCodec::codecForName(NameCodec);  // "Windows-1251" "UTF-8"
	*qstr = codec->toUnicode(strz);
}
// !!! Из QString в CHAR *
extern "C" FQT_API void QT_QString_text(QString *qstr, char *strz) {
	QTextCodec *codec = QTextCodec::codecForName(NameCodec);  // "Windows-1251"  "UTF-8"
	sprintf((strz+1), "%s\0", codec->fromUnicode(*qstr).data());
	*strz = strlen(strz+1);
}
// ==================== QTextEdit ======================
gTextEdit::gTextEdit( QWidget* parent)    : QTextEdit( parent )
{
}
gTextEdit::~gTextEdit()
{
}
// !!! Выдать QTextEdit на стек
extern "C" FQT_API void *QT_QTextEdit(QWidget* parent) {
	return  new gTextEdit(parent);
}
// !!! Append
extern "C" FQT_API void QT_QTextEdit_append(QWidget* qw, QString *qstr) {
	((gTextEdit *)qw)->append(*qstr);
}
// !!! Clear
extern "C" FQT_API void QT_QTextEdit_clear(QWidget* qw) {
	((gTextEdit *)qw)->clear();
}

// ==================== QLineEdit ======================
gLineEdit::gLineEdit(QWidget * parent) : QLineEdit(parent)
{
	aReturnPressed = NULL;
}

gLineEdit::~gLineEdit()
{
}
void gLineEdit::returnPressed1()
{
	if (aReturnPressed != NULL) ((ExecZIM_0_0)aReturnPressed)();
}
// !!! Выдать QLineEdit на стек
extern "C" FQT_API void *QT_QLineEdit(QWidget* parent) {
	return  new gLineEdit(parent);
}
// !!! Установить обработчик
extern "C" FQT_API void QT_QLineEdit_onreturnPressed(gLineEdit* qw, void *uk) {
	qw->aReturnPressed = uk;
    qw->connect(qw, SIGNAL( returnPressed() ), qw, SLOT( returnPressed1()));
}
// !!! Текст строки LineEdit в QString
extern "C" FQT_API void QT_QLineEdit_text(gLineEdit* qw, QString *qstr) {
     *qstr = qw->text();
}
// !!! SetFocus LineEdit
extern "C" FQT_API void QT_QLineEdit_setfocus(gLineEdit* qw) {
     qw->setFocus();
}
// !!! Clear LineEdit
extern "C" FQT_API void QT_QLineEdit_clear(gLineEdit* qw) {
     qw->clear();
}
// ==================== QMsgBox ======================
extern "C" FQT_API void *QT_QMessageBox(void)
{
	return  new QMessageBox();
}
extern "C" FQT_API int QT_QMessageBox_infb(QMessageBox *msgbox, QWidget *parent,
					   int tip,int kn,QString *zag,QString *soob)
{
     int zn;
     zn=0;
	 if (tip == 1) {
		zn = msgbox->information(parent, *zag, *soob, (QMessageBox::StandardButtons)kn);
	 }
	 if (tip == 3) {
		zn = msgbox->critical(parent, *zag, *soob, (QMessageBox::StandardButtons)kn);
	 }
	 if (tip == 4) {
		zn = msgbox->question(parent, *zag, *soob, (QMessageBox::StandardButtons)kn);
	 }
	 if (tip == 2) {
		zn = msgbox->warning(parent, *zag, *soob, (QMessageBox::StandardButtons)kn);
	 }
	 if (tip == 5) {
		msgbox->aboutQt(0);
	 }
     return zn;
}
extern "C" FQT_API int QT_add3(int a1, int a2, int a3, int a4, int a5, int a6)
{
     return a1+a2+a3+a4+a5+a6;
}
// /* +++++++++++++++++++++++++ QLyout +++++++++++++++++++++++++++ 
extern "C" FQT_API void *QT_QVBoxLayout(void)
{
	return  new QVBoxLayout();
}
extern "C" FQT_API void *QT_QHBoxLayout(void)
{
	return  new QHBoxLayout();
}
extern "C" FQT_API void QT_QBoxLayout_addWidget(QBoxLayout *BoxLyout, QWidget *widget)
{
     BoxLyout->addWidget(widget);
}
extern "C" FQT_API void QT_QBoxLayout_addLayout(QBoxLayout *BoxLyout, QLayout *layout)
{
     BoxLyout->addLayout(layout);
}
// /* +++++++++++++++++++++++++ StatusBar +++++++++++++++++++++++++++ 
extern "C" FQT_API void *QT_QStatusBar(QWidget* parent)
{
       return new QStatusBar(parent);
}
extern "C" FQT_API void QT_QStatusBar_setMes(QStatusBar *sb, QString *qstr)
{
     sb->showMessage(*qstr);
}
// /* ------------------------- QMainWindow ----------------------- 
extern "C" FQT_API void *QT_QMainWindow(void)
{
     return new QMainWindow();
}
extern "C" FQT_API void QT_QMainWindow_setCentralWidget(QMainWindow *mw, QWidget *win)
{
     mw->setCentralWidget(win);
}
extern "C" FQT_API void QT_QMainWindow_setStatusBar(QMainWindow *mw, QStatusBar *sb)
{
     mw->setStatusBar(sb);
}
extern "C" FQT_API void QT_QMainWindow_setMenuBar(QMainWindow *mw, QMenuBar *sb)
{
     mw->setMenuBar(sb);
}
// /* ------------------------- QDialog ----------------------- 

// !!! Выдать QWidget на стек
extern "C" FQT_API void *QT_QDialog(QWidget* parent, int  f) {
        return  new QDialog(parent, (Qt::WindowFlags)f);
}

// /* ------------------------- QPushButton -----------------------

gPushButton::gPushButton(QWidget * parent, const char * name) : QPushButton(name, parent)
{
        aOnClick = NULL;
}

gPushButton::~gPushButton()
{
}

void gPushButton::OnClick()
{
    if (aOnClick!= NULL)  ((ExecZIM_0_0)aOnClick)();
}
extern "C" FQT_API void *QT_QPushButton(QWidget * parent, const char * name) {
        return  new gPushButton(parent, name);
}
extern "C" FQT_API void *QT_QPushButton_OnClick(gPushButton *kn, void* adr) {
     kn->aOnClick = adr;    // Указатель на слово
     kn->connect(kn, SIGNAL( clicked() ), kn, SLOT( OnClick()));
}
