//#define WINDOWSF
#define LINUXF

#ifdef LINUXF
  #include <QApplication>
  #include <QPushButton>
  #include <QTextEdit>
  #include <QLineEdit>
  #include <QTextCodec>
  #include <QMessageBox>
  #include <QtGui>
#endif
#ifdef WINDOWSF
  #include <QtGui\QApplication>
  #include <QtGui\QPushButton>
  #include <QtGui\QTextEdit>
  #include <QtGui\QLineEdit>
#endif

class gPushButton : public QPushButton
{
    Q_OBJECT
public:
        gPushButton( QWidget * parent, const char * name = 0 );
        ~gPushButton();
        void *aOnClick;
public slots:
        void OnClick();
};

class gLineEdit : public QLineEdit
{
    Q_OBJECT
public:
	gLineEdit(QWidget * parent = 0);
	~gLineEdit();
        void *aReturnPressed;
public slots:
        void returnPressed1();
};


class gTextEdit : public QTextEdit
{
    Q_OBJECT
public:
	gTextEdit ( QWidget * parent );
	~gTextEdit();
};


class zQWidget : public QWidget
{
    Q_OBJECT
public:
    zQWidget( QWidget* parent = 0 );
    ~zQWidget();
    void *aOnResize;
    void *aMouseMoveEvent;
    void *aHideEvent;
    void resizeEvent( QResizeEvent * );
    void mouseMoveEvent( QMouseEvent * );
    void hideEvent( QHideEvent * );
};
