\ Библиотека определений Мохов Г.В. 22.03.10 20:02 http://mgw.narod.ru/
\ для привочного вида кода

1 CONSTANT MGW                  \  Для REQUIRE
: // POSTPONE \ ; IMMEDIATE  // Комментарий для совместимости с C++

: if=W    // Делай если  Windows
    PLATFORM DROP C@ 76 = IF POSTPONE \ THEN ; IMMEDIATE
: if=L    // Делай если  Linux
    PLATFORM DROP C@ 87 = IF POSTPONE \ THEN ; IMMEDIATE

if=W S" lib\ext\spf-asm.f" INCLUDED
if=W S" args.f"            INCLUDED
if=L S" lib/ext/spf-asm.f" INCLUDED
if=L S" lib/ext/disasm.f"  INCLUDED

// Работает и в Windows и Linux
if=W CODE C-CALL ( x1 ... xn n adr -- res ) \ int fun(x1 .. xn);
if=W      MOV EBX, [EBP]      \ число аргументов
if=W      MOV ESI, # 4
if=W @@1: OR EBX, EBX
if=W      JZ @@2
if=W A;   0xFF C, 0x74 C, 0x35 C, 0x00 C,
if=W      LEA ESI, 4 [ESI]
if=W      DEC EBX
if=W      JMP @@1
if=W @@2: CALL EAX
if=W      MOV ECX, [EBP]
if=W      SHL ECX, # 2
if=W      ADD ESP, ECX
if=W      ADD ECX, # 4
if=W      ADD EBP, ECX
if=W      RET
if=W END-CODE

CODE THIS-C-CALL ( Aobj x1 ... xn n adr -- res ) \ int fun(x1 .. xn);
      MOV EBX, [EBP]      \ число аргументов
      MOV ESI, # 4
@@1:  OR EBX, EBX
      JZ @@2
A;    0xFF C, 0x74 C, 0x35 C, 0x00 C,
      LEA ESI, 4 [ESI]
      DEC EBX
      JMP @@1
@@2:  MOV ECX, [EBP]
      CALL EAX
      MOV ECX, [EBP]
      SHL ECX, # 2
      ADD ESP, ECX
      ADD ECX, # 4
      ADD EBP, ECX
      RET
END-CODE

CODE API-CALL ( ... extern-addr -- x )
\ вызов внешней функции (API или метода объекта через COM)
      PUSH EDI
      PUSH EBP
      SUB  ESP, # 60
      MOV  EBX, EDI
      MOV  EDI, ESP
      MOV  ESI, EBP
      MOV  ECX, # 15
      CLD
      REP MOVS DWORD
      MOV  EBP, ESP
      MOV  EDI, EBX
      CALL EAX
      MOV  EBX, EBP
      SUB  EBX, ESP
      MOV  ESP, EBP
      ADD  ESP, # 60
      POP EBP
      SUB EBP, EBX
      POP EDI
      RET
END-CODE

CODE (CAPI-CALL) ( EAX - extern-addr, ECX - n -- x )
      OR   ECX, ECX
      JZ   SHORT @@1
      LEA  EBX, [ECX*4]
      SUB  ESP, EBX
      MOV  EDX, EDI
      MOV  EDI, ESP
      MOV  ESI, EBP
      CLD
      REP MOVS DWORD
      MOV EDI, EDX
      ADD EBP, EBX
      CALL EAX
      ADD  ESP, EBX
      RET

@@1:  CALL EAX
      RET
END-CODE

CODE CAPI-CALL ( ... n extern-addr -- x )
\ вызов внешней функции, экспортированной по c-правилам
      MOV  ECX, [EBP]
      LEA  EBP, 4 [EBP]
      CALL ' (CAPI-CALL)
      RET
END-CODE

// Это злосчастный вызов __thiscall которого оказываеться нет в SPF
CODE (THIS-CDECL-CALL) // ( .... EAX - extern-addr, ECX - n -- x )
      OR   ECX, ECX
      JZ   SHORT @@1
      LEA  EBX, [ECX*4]
      SUB  ESP, EBX
      MOV  EDX, EDI
      MOV  EDI, ESP
      MOV  ESI, EBP
      CLD
      REP MOVS DWORD
      MOV EDI, EDX
      ADD EBP, EBX
      MOV ECX, [EBP]
      CALL EAX
      ADD  ESP, EBX
      JMP SHORT @@2
@@1:  MOV ECX, [EBP]
      CALL EAX
@@2:  MOV EAX, 4 [EBP]
      LEA  EBP, 8 [EBP]
      LEA EBP, -4 [EBP]
      RET
END-CODE

// Вызов конструктора C++ по типу: _cdecl
// Аргументы в обратном порядке
CODE THIS-CDECL-CALL // ( ArgN ArgN-1 ... Arg1 n extern-addr -- x )
      MOV  ECX, [EBP]
      LEA  EBP, 4 [EBP]
      CALL ' (THIS-CDECL-CALL)
      RET
END-CODE

CODE (THIS-CDECL-CALL-ECX) // ( .... EAX - extern-addr, ECX - n -- x )
      OR   ECX, ECX
      JZ   SHORT @@1
      LEA  EBX, [ECX*4]
      SUB  ESP, EBX
      MOV  EDX, EDI
      MOV  EDI, ESP
      MOV  ESI, EBP
      CLD
      REP MOVS DWORD
      MOV EDI, EDX
      ADD EBP, EBX
      MOV ECX, [EBP]
      CALL EAX
      ADD  ESP, EBX
      JMP SHORT @@2
@@1:  MOV ECX, [EBP]
      CALL EAX
@@2:  MOV EAX, 4 [EBP]
      LEA  EBP, 8 [EBP]
      LEA EBP, -4 [EBP]
      MOV EAX, ECX
      RET
END-CODE

// Вызов конструктора C++ по типу: _cdecl
// Аргументы в обратном порядке
CODE THIS-CDECL-CALL-ECX // ( ArgN ArgN-1 ... Arg1 n extern-addr -- x )
      MOV  ECX, [EBP]
      LEA  EBP, 4 [EBP]
      CALL ' (THIS-CDECL-CALL-ECX)
//      LEA EBP, -4 [EBP]
      RET
END-CODE

// Работает и в Win и Linux
CODE (CDECL-CALL) ( EAX - extern-addr, ECX - n -- x )
      OR   ECX, ECX
      JZ   SHORT @@1
      LEA  EBX, [ECX*4]
      SUB  ESP, EBX
      MOV  EDX, EDI
      MOV  EDI, ESP
      MOV  ESI, EBP
      CLD
      REP MOVS DWORD
      MOV EDI, EDX
      ADD EBP, EBX
      CALL EAX
      ADD  ESP, EBX
      RET

@@1:  CALL EAX
      RET
END-CODE

CODE CDECL-CALL ( ArgN ArgN-1 ... Arg1 n extern-addr -- x )
\ вызов внешней функции, экспортированной по c-правилам
      MOV  ECX, [EBP]
      LEA  EBP, 4 [EBP]
      CALL ' (CDECL-CALL)
      RET
END-CODE
// Слова  PAS-EXEC и C-EXEC взяты из файла ~ac\lib\ns\so-xt.f
USER _PAS-EXEC \ без локальных переменных неудобно ;)
: PAS-EXEC ( ... n dll-xt -- x )
\ n - число параметров на стеке для dll-функции
\ Параметры снимает вызываемый.
  _PAS-EXEC !
  ?DUP IF N>R RDROP THEN
  0 _PAS-EXEC @ EXECUTE
;
USER _C-EXEC
: C-EXEC ( ... n dll-xt -- x )
\ n - число параметров на стеке для dll/so-функции
\ Параметры снимает вызывающий.
  _PAS-EXEC ! DUP _C-EXEC !
  ?DUP IF N>R RDROP THEN
  _C-EXEC @ 0 _PAS-EXEC @ EXECUTE
  SWAP BEGIN DUP WHILE RDROP 1- REPEAT DROP
;

// Подсмотрел у ~yz
S" lib/include/float.f" INCLUDED
: float [                 
  0x8D C, 0x6D C, 0xFC C, 
  0xD9 C, 0x5D C, 0x00 C, 
  0x87 C, 0x45 C, 0x00 C, 
  0xC3 C, ] ;             
: double FLOAT>DATA SWAP ;
( CODE float                                         
       LEA  EBP, -4 [EBP]
       FSTP  DWORD [EBP] 
       XCHG  EAX, [EBP]  
       RET               
END-CODE)

// --------------------------------------------------
// 
: ASCIIZ" ( ->" ) [CHAR] " PARSE 
 HERE OVER ALLOT SWAP CMOVE 0 C,
;

// Работа с функциями DLL. Использует структуру даных двух типов: 
// library - начало списка, адрес загруженной DLL
// call - адрес функции и указатель на след в списке
1 CONSTANT LibraryLoad    // Загрузить DLL и загрузить функции в связанном списке
2 CONSTANT Library@       // Выдать адрес структуры Library
// Создаёт слово для создания активных слов загрузки динамич библиотек
// Использование:  Library" fqt.dll" fqt   // создать слово fqt
//                 LibraryLoad fqt         // загрузить библиотеку и иниц список функций
// Внутренняя структура library:
//  +----------- CELL ----------+----------- CELL ------------------+---- длина + 0 в конце --+
//  | адрес загрузки библиотеки | Указатель на слова функций        | имя библиотеки (ascciz) |
//  +---------------------------+-----------------------------------+-------------------------+
: Library"    // ( -- ) Library" fqt.dll" fqt 
      HERE >R 0 HERE ! CELL ALLOT 0 HERE ! CELL ALLOT // выделить две ячейки и занулить их
      ASCIIZ"                                         // сохранение имени DLL
      R> CREATE ,                                     // создаём словарную статью
   DOES>  
      SWAP DUP                                        // Анализируем параметр
          1 = IF DROP                                 // Идем по списку, грузим адреса функций
                  @                                   // Alibrary
                  DUP 2 CELLS +                       // Alibrary Astr
if=W    LoadLibraryA             // Грузанем DLL в Windows
if=L    DLOPEN-FLAG              // флаги для работы dlopen()
if=L    SWAP 2                   // порядок аргументов на стеке обратный и их 2 штуки
if=L    dlopen-adr @ CDECL-CALL  // вызов dlopen("filename", DLOPEN-FLAG);
        DUP 0 = IF S" Error load DLL " TYPE DROP 2 CELLS +  ASCIIZ>  TYPE CR BYE 
                THEN 
                  DUP >R OVER !      // Сохраним адр загруженной DLL в структуре и в SP                                    
                  CELL + @           // Берем структуру Call по указателю
                  BEGIN  
                    DUP 4 CELLS +                     // Acall Aстроки
         // Здесь грузим функции   ( Acall Astr -- )  
         R@                      //  Acall Astr Adll
if=W    GetProcAddress           // Найдем точку входа
if=L    2                        // 2 аргумента, порядок обратный	
if=L    dlsym-adr @ CDECL-CALL   // вызов dlsym(h, "procname");
        DUP 0 = IF S" Error find function " TYPE DROP 4 CELLS +  ASCIIZ>  TYPE CR BYE 
                THEN
        OVER !                   //  Сохраним адрес функции в структуре Call
        // --------------------
                    2 CELLS + @  DUP 0 =              // След структура в списке или последняя
                  UNTIL DROP
                  R> DROP
              ELSE 
          2 = IF @ ELSE  S" Ошибочный параметр Library" TYPE 
              THEN THEN
      ;
// Создаёт слово для работы с адресом функции DLL и выполнением вызова
// Перед использованием необходима инициализация:  LibraryLoad fqt   // загрузить библиотеку и иниц
// Использование: Library@ fqt #Кол_вход_параметров CDECL-Call" QT_App" QT_App  // Добавить в список вызова
// Вызов функции:          аргументы  QT_App  // Перед 
// Внутренняя структура call:
//  +--- CELL ------+------ CELL ------+----- CELL --------+-----CELL ----+-- длина + 0 в конце --+
//  | адрес функции | Кол входн парам  | адрес след или 0  | тип вызова   | имя функции (ascciz)  |
//  +---------------+------------------+-------------------+--------------+-----------------------+
: _-Call"            // ( Aструкт_library #Кол_параметров #типвызова -- )
      HERE >R 0 HERE ! CELL ALLOT SWAP HERE !              // 0= адр функции и сохр кол вход параметров
      CELL ALLOT R@ 3 CELLS + !                            // Сохраним тип вызова
    R@ SWAP CELL + DUP >R @ HERE ! R> ! 
      2 CELLS ALLOT // выделить три ячейки и занулить
      ASCIIZ"                                              // сохранение имени вызываемой функции
      CREATE R> , DOES> @ DUP >R 3 CELLS + @ 
	  DUP 1 = IF DROP R> DUP CELL + @ SWAP @  C-EXEC              // CDECL
	      ELSE
	  DUP 2 = IF DROP R> DUP CELL + @ SWAP @  PAS-EXEC            // STDCAL/WINAPI
	      ELSE
	  DUP 4 = IF DROP R> DUP CELL + @ SWAP @  THIS-CDECL-CALL-ECX    // По типу MS VC
	      ELSE
	  DUP 5 = IF DROP R> DUP CELL + @ 1+ SWAP @ C-EXEC
	      ELSE
	  DUP 3 = IF DROP R> @                                       // GLOBAL Extern
	  THEN
	  THEN
	  THEN
	  THEN
	  THEN
      ;      
: CDECL-Call"   1 _-Call" ;
: STDCALL-Call" 2 _-Call" ;
: WINAPI-Call"  2 _-Call" ;
: Extern"     0 3 _-Call" ;
: THIS-CDECL-Win-VC-Call" 4 _-Call" ;      // ( Aobj Nn ... N1 -- rez ) Аызвать метод MS VC ....
: THIS-CDECL-Linux-gcc-Call" ;             // Надо сделать
: THIS-CDECL-Win-MinGW-Call" 5 _-Call" ; 

// Обработка строк
: CONST$   // ( n -- ) Создать константу, под строку в n байт в памяти
   HERE SWAP ALLOT CREATE , DOES> @ 
   ;
: A>CS     // ( addr u cs -- ) Скопировать строку adr u в буфер cs
       2DUP C! 2DUP + 1+ 0 SWAP C! 1+ SWAP CMOVE
   ;
: CS+A     // ( cs addr u -- ) Склеить строки
       ROT DUP >R ROT OVER COUNT + ROT DROP >R OVER R> SWAP CMOVE            
       R@ C@ + R@ C! R> COUNT + 0 SWAP C!
   ;



